# Repository path:    $HeadURL: https://90.145.156.222/DMS-Houtribdijk/code/python-ftp-svn/source/TestRoutines.py $
# Last committed:     $Revision: 115670 $; $Author: jverkaik $; $Date: 2019-05-21 09:16:21 +0200 (di, 21 mei 2019) $
#
from DmsLogger import DmsLogger
from DmsDb import DmsDb
from datetime import datetime, timedelta


def add_file_to_file_log(
    logger,
    remote_path,
    local_path,
    file,
    problem_type,
    first_reported,
    last_processed,
    times_processed,
):
    db = DmsDb(logger)
    db.add_file_to_list(
        remote_path,
        local_path,
        file,
        problem_type,
        first_reported,
        last_processed,
        times_processed,
    )
    db.close()


def remove_file_from_file_log(logger, remote_path, local_path, file):
    db = DmsDb(logger)
    db.remove_file_from_list(remote_path, local_path, file)
    db.close()


def read_file_from_file_log(logger, remote_path, local_path, file):
    db = DmsDb(logger)
    test_dict = db.read_file_from_list(remote_path, local_path, file)
    db.close()
    return test_dict


def update_file_in_file_log(logger, remote_path, local_path, file):
    db = DmsDb(logger)
    db.update_file_in_list(remote_path, local_path, file)
    db.close()


def get_files_from_file_log(logger):
    db = DmsDb(logger)
    df = db.read_all_files_from_list()
    db.close()
    return df


def db_tests():

    logger = DmsLogger.set_logger("./testLogs", "test-logger", "test-log.out")

    now = datetime.now()
    not_now = datetime.now() - timedelta(minutes=3)
    add_file_to_file_log(logger, "remotepath", "lp", "file3", "ftp", now, not_now, 2)
    add_file_to_file_log(logger, "path", "lp1", "file", "ftp", now, not_now, 2)
    add_file_to_file_log(logger, "path", "lp1", "file2", "ftp", now, not_now, 2)
    remove_file_from_file_log(logger, "path", "lp1", "file2")
    remove_file_from_file_log(logger, "path", "lp1", "file4")

    test_dict = read_file_from_file_log(logger, "path", "lp1", "file")
    print(test_dict["lastprocessed"])

    update_file_in_file_log(logger, "path", "lp1", "file")

    test_dict = read_file_from_file_log(logger, "path", "lp1", "file")
    print(test_dict["lastprocessed"])

    df = get_files_from_file_log(logger)
    print(df.head())


if __name__ == "__main__":
    db_tests()
